using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine;
using UnityEngine.SceneManagement;
using System.Linq;
using TMPro;
using UnityEngine.UI;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
CategoryBuilder.Create(" Hot Wired", "", ModAPI.LoadSprite("category icon.png"));       




                        

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[HW] HK416",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/hk416icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var M4A1Slide = Instance.transform.Find("Slide");
                       M4A1Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/hk416slide.png", 16f);
                       M4A1Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/hk416.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.210f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.13f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/hksound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45mm";
                        customCartridge.Damage *= 20f;
                        customCartridge.Recoil *= 5f;
                        customCartridge.ImpactForce *= 6f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "[HW] Glock Flux Defense Stock",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5b",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/glock1icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();
						
		       var GlockSlide = Instance.transform.Find("Slide");
                       GlockSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/glockslide.png", 24f);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/glock.png", 24f);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.24f, 0.06f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
  
                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/glocksound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage *= 18f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 0.9f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "[HW] Glock Flux Defense Stock + Red Dot Sight",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5c",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/glock2icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();
						
		       var GlockSlide = Instance.transform.Find("Slide");
                       GlockSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/glock2slide.png", 24f);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/glock.png", 24f);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.24f, 0.06f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
  
                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/glocksound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage *= 18f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 0.9f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "[HW] Glock Flux Defense Stock [Tan]",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5d",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/glocktan1icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();
						
		       var GlockSlide = Instance.transform.Find("Slide");
                       GlockSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/glockslide.png", 24f);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/glocktan.png", 24f);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.24f, 0.06f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
  
                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/glocksound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage *= 18f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 0.9f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "[HW] Glock Flux Defense Stock + Red Dot Sight [Tan]",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5e",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/glocktan2icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();
						
		       var GlockSlide = Instance.transform.Find("Slide");
                       GlockSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/glock2slide.png", 24f);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/glocktan.png", 24f);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.24f, 0.06f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
  
                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/glocksound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage *= 18f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 0.9f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[HW] Helmet Variant 1.", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2a",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[HW] Helmet Variant 2.", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2b",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateLight(Instance.transform, Color.cyan, 0.3f, 0.5f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(4.2f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[HW] Helmet Variant 3.", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2c",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[HW] Helmet Variant 4.", 
                    DescriptionOverride = "",
                    NameToOrderByOverride = "2d", 
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv4.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateLight(Instance.transform, Color.cyan, 0.3f, 0.5f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv4.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(4.2f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[HW] Vest Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3a",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vesticon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest1.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest1.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[HW] Vest Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3b",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest12.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest12.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest22.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[HW] Vest Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3c",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest13.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest13.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest23.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[HW] Belt", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4a",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/belticon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/belt.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/belt.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[HW] Waist Bag", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4b",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/Waistbagicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/Waist Bag.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/Waist Bag.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[HW] Variant 1",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1A",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/outfitsicon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/variant1.png"),
                        };
                    }
                }
            );          

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[HW] Variant 2",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1b",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/outfits2icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/variant2.png"),
                        };
                    }
                }
            );          

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[HW] Variant 3",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1b",
                    CategoryOverride = ModAPI.FindCategory(" Hot Wired"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/outfits3icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/variant3.png"),
                        };
                    }
                }
            );  
       
              





        }


public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
        public Texture2D[] Textures = new Texture2D[0];
        public PersonBehaviour person;
        public int CurrentTexture = -2;
        public int Scale = 3;

        void Start()
        {
            SetTexture();
        }

        public void SetTexture()
        {
            if (Textures.Length == 0)
                return;

            if(CurrentTexture == -2)
            {
                CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
            }
            person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
            for (int i = 0; i < person.Limbs.Length; i++)
            {
                person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
            }
        }
}    }
}
